
datablock ItemData(AmmoBowFastItem : AmmoBowItem)
{
	uiName = "Ammo Bow Fast";
	colorShiftColor = "0.2 0.08 0 1";

	image = AmmoBowFastImage;
};

datablock ShapeBaseImageData(AmmoBowFastImage : AmmoBowImage) {
	item = AmmoBowFastItem;
	colorShiftColor = AmmoBowFastItem.colorShiftColor;

	stateTimeoutValue[3]            = 0.5;
	stateTimeoutValue[5]            = 0.15;
};

function AmmoBowFastImage::onUnmount(%this, %obj, %slot)
{
	if (isObject(%obj.client))
		%obj.client.centerprint();
}

function AmmoBowFastImage::onAmmoCheck(%this, %obj, %slot)
{
	%obj.numArrows = getMin(%obj.numArrows, $Pref::AmmoBow::MaxAmmo);
	if (%obj.numArrows > 0)
	{
		%obj.setImageAmmo(%slot, 1);
		%arrows = "\c3" @ %obj.numArrows;
	}
	else
	{
		%obj.setImageAmmo(%slot, 0);
		%arrows = "\c0" @ (%obj.numArrows = 0);
	}

	if (isObject(%obj.client))
		%obj.client.centerprint("<just:right><color:ffffff>Arrows: \c3" @ %obj.numArrows @ "/" @ $Pref::AmmoBow::MaxAmmo @ " ", -1);
}

function AmmoBowFastImage::onFire(%this, %obj, %slot)
{
	%obj.numArrows--;
	parent::onFire(%this, %obj, %slot);
}


////////////////////


datablock ItemData(AmmoBowVeryFastItem : AmmoBowItem)
{
	uiName = "Ammo Bow Fastest";
	colorShiftColor = "0.1 0.1 0.1 1";

	image = AmmoBowVeryFastImage;
};

datablock ShapeBaseImageData(AmmoBowVeryFastImage : AmmoBowImage) {
	item = AmmoBowVeryFastItem;
	colorShiftColor = AmmoBowVeryFastItem.colorShiftColor;

	stateTimeoutValue[3]            = 0.25;
	stateTimeoutValue[5]            = 0.15;
};

function AmmoBowVeryFastImage::onUnmount(%this, %obj, %slot)
{
	if (isObject(%obj.client))
		%obj.client.centerprint();
}

function AmmoBowVeryFastImage::onAmmoCheck(%this, %obj, %slot)
{
	%obj.numArrows = getMin(%obj.numArrows, $Pref::AmmoBow::MaxAmmo);
	if (%obj.numArrows > 0)
	{
		%obj.setImageAmmo(%slot, 1);
		%arrows = "\c3" @ %obj.numArrows;
	}
	else
	{
		%obj.setImageAmmo(%slot, 0);
		%arrows = "\c0" @ (%obj.numArrows = 0);
	}

	if (isObject(%obj.client))
		%obj.client.centerprint("<just:right><color:ffffff>Arrows: \c3" @ %obj.numArrows @ "/" @ $Pref::AmmoBow::MaxAmmo @ " ", -1);
}

function AmmoBowVeryFastImage::onFire(%this, %obj, %slot)
{
	%obj.numArrows--;
	parent::onFire(%this, %obj, %slot);
}


////////////////////


datablock ItemData(AmmoBowShotgunItem : AmmoBowItem)
{
	uiName = "Ammo Bow Shotgun";
	colorShiftColor = "0.6 0.2 0.15 1";

	image = AmmoBowShotgunImage;
};

datablock ShapeBaseImageData(AmmoBowShotgunImage : AmmoBowImage) {
	item = AmmoBowShotgunItem;
	colorShiftColor = AmmoBowShotgunItem.colorShiftColor;

	stateTimeoutValue[3]            = 0.95;
	stateTimeoutValue[5]            = 0.15;
};

function AmmoBowShotgunImage::onUnmount(%this, %obj, %slot)
{
	if (isObject(%obj.client))
		%obj.client.centerprint();
}

function AmmoBowShotgunImage::onAmmoCheck(%this, %obj, %slot)
{
	%obj.numArrows = getMin(%obj.numArrows, $Pref::AmmoBow::MaxAmmo);
	if (%obj.numArrows > 0)
	{
		%obj.setImageAmmo(%slot, 1);
		%arrows = "\c3" @ %obj.numArrows;
	}
	else
	{
		%obj.setImageAmmo(%slot, 0);
		%arrows = "\c0" @ (%obj.numArrows = 0);
	}

	if (isObject(%obj.client))
		%obj.client.centerprint("<just:right><color:ffffff>Arrows: \c3" @ %obj.numArrows @ "/" @ $Pref::AmmoBow::MaxAmmo @ " ", -1);
}

function AmmoBowShotgunImage::onFire(%this, %obj, %slot)
{
	if(%obj.lastFireTime + %this.minShotTime > getSimTime())
		return;
	%obj.lastFireTime = getSimTime();

	%arrows = getMin(%obj.numArrows, 4);
	%obj.numArrows -= %arrows;

	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();

	%projectile = %this.projectile;
	%spread = 0.003;

	for(%shell = 0; %shell < %arrows; %shell++)
	{
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		if (%shell != 0)
			%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
}